#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "lib.h"

vector_t *vector_set(vector_t *vd, double x, double y, double z)
{
  vd->x = x;
  vd->y = y;
  vd->z = z;
  return vd;
}

vector_t *vector_zero(vector_t *vd)
{
  return vector_set(vd, 0.0, 0.0, 0.0);
}

vector_t *vector_rand(vector_t *vd)
{
  return vector_set(vd,
		    ((rand() % 20001) - 10000) * 0.0001,
		    ((rand() % 20001) - 10000) * 0.0001,
		    ((rand() % 20001) - 10000) * 0.0001);
}

vector_t *vector_add(vector_t *vd, vector_t *v0, vector_t *v1)
{
  return vector_set(vd, v0->x + v1->x, v0->y + v1->y, v0->z + v1->z);
}

vector_t *vector_sub(vector_t *vd, vector_t *v0, vector_t *v1)
{
  return vector_set(vd, v0->x - v1->x, v0->y - v1->y, v0->z - v1->z);
}

vector_t *vector_mul(vector_t *vd, vector_t *v0, double r)
{
  return vector_set(vd, v0->x * r, v0->y * r, v0->z * r);
}

vector_t *vector_div(vector_t *vd, vector_t *v0, double r)
{
  return (r == 0.0) ? NULL : vector_set(vd, v0->x / r, v0->y / r, v0->z / r);
}

vector_t *vector_normalize(vector_t *vd)
{
  return vector_div(vd, vd, vector_length(vd));
}

double vector_square(vector_t *vd)
{
  return vd->x * vd->x + vd->y * vd->y + vd->z * vd->z;
}

double vector_length(vector_t *vd)
{
  return sqrt(vector_square(vd));
}
