#ifndef _SAUCER_LIB_H_INCLUDED_
#define _SAUCER_LIB_H_INCLUDED_

typedef struct {
  double x;
  double y;
  double z;
} vector_t;

vector_t *vector_set(vector_t *vd, double x, double y, double z);
vector_t *vector_zero(vector_t *vd);
vector_t *vector_rand(vector_t *vd);
vector_t *vector_add(vector_t *vd, vector_t *v0, vector_t *v1);
vector_t *vector_sub(vector_t *vd, vector_t *v0, vector_t *v1);
vector_t *vector_mul(vector_t *vd, vector_t *v0, double r);
vector_t *vector_div(vector_t *vd, vector_t *v0, double r);
vector_t *vector_normalize(vector_t *vd);

double vector_square(vector_t *vd);
double vector_length(vector_t *vd);

#endif
